/*****************************************************************************/
//	BuiltinUnaryRelation.h
/*****************************************************************************/

#ifndef _BuiltinUnaryRelation_H_
#define _BuiltinUnaryRelation_H_

#include "BuiltinRelation.h"

/*****************************************************************************/

typedef const corCArg (*AggProc)(corRelation* rel);

/*****************************************************************************/

class corBuiltinUnaryRelation : public corBuiltinRelation {
public:
	//  Arg* first ;   used for storing aggregate value 
	//  Arg* second ; used by average to store count 
	AggProc op;

	corBuiltinUnaryRelation(int a, Name n, AggProc agg_op);

	virtual corBindEnv* get_next(corTupleIterator&);
	int is_printable_builtin() {return 0;}
};

/*****************************************************************************/

#endif _BuiltinUnaryRelation_H_

