//*********************************************************************
//    Identify.h
//
//    Including this file will define HPUX, SUN, MIPS, or OTHER. 
//    (should probably contain VMS, SOLAR, and some others)
//
//*********************************************************************

#ifndef    _Identify_H
#define    _Identify_H

// HPUX - 

#ifdef    _HPUX_SOURCE
#    define    HPUX
#endif

//*********************************************************************

// SUN 

#ifdef    sun
#    define    SUN
#endif

//*********************************************************************

// MIPS - 

#ifdef    __MIPSEL
#    define    MIPS
#endif

//*********************************************************************

#ifdef    __linux
#    define    LINUX
#endif

//*********************************************************************

// Catch all for others

#if !defined(HPUX) && !defined(SUN) && !defined(MIPS)
#    define    OTHER
#endif 

//*********************************************************************

#endif     // _Identify_H
