/*****************************************************************************/
//    Operators.h
/*****************************************************************************/

#ifndef _Operators_H_
#define _Operators_H_

/*****************************************************************************/

class corTuple;
class corArg;
class corRelation;
class corTerm;
class corBuiltinRelation;
class corTupleIterator;
class corBindEnv;

class corCArg;
/*****************************************************************************/

corTuple* corFuncOp(corTuple* query);
corTuple* ArgOp(corTuple* query);
const corCArg corAddOp(const corCArg arg0, const corCArg arg1);
const corCArg corSubOp(const corCArg arg0, const corCArg arg1);
const corCArg corMulOp(const corCArg arg0, const corCArg arg1);
const corCArg corDivOp(const corCArg arg0, const corCArg arg1);

const corCArg corSumOp(corRelation* rel);
const corCArg corProdOp(corRelation* rel);
const corCArg corAvgOp(corRelation* rel);
const corCArg corCountOp(corRelation* rel);
extern const corCArg corMinOp(corRelation* rel);
extern const corCArg corMaxOp(corRelation * rel);

int corEquOp(corTerm& term0, corTerm& term1);
int corNeqOp(corTerm& term0, corTerm& term1);
int corLssOp(corTerm& term0, corTerm& term1);
int corGrtOp(corTerm& term0, corTerm& term1);
int corLeqOp(corTerm& term0, corTerm& term1);
int corGeqOp(corTerm& term0, corTerm& term1);
int corCopyTermOp(corTerm& term0, corTerm& term1);
const corCArg corLShiftOp(const corCArg arg0, const corCArg arg1);
const corCArg corRShiftOp(const corCArg arg0, const corCArg arg1);
const corCArg corBitorOp(const corCArg arg0, const corCArg arg1);
const corCArg corBitandOp(const corCArg arg0, const corCArg arg1);
const corCArg corBitxorOp(const corCArg arg0, const corCArg arg1);
const corCArg corModOp(const corCArg arg0, const corCArg arg1);
corBindEnv* corGoalIdOp(corBuiltinRelation& , corTupleIterator& iter);

/*****************************************************************************/

#endif _Operators_H_

