
/* Anagram code from comp.lang.prolog,
   courtesy of:
        John Garland
        jgarland@kean.ucs.mun.ca

   Computes all permutations of a list.
*/
 

module permute.
export permute[bf].

    delete_member(X,[X|T],T).
    delete_member(X,[H|T],[H|Rest]) :- delete_member(X,T,Rest).

    permute([X],[X]).
    permute(List,[X|Final]) :-

       delete_member(X,List,Newlist),
       permute(Newlist,Final).

end_module.

