/*****************************************************************************/
//    BuiltinFailRelation.h
/*****************************************************************************/

#ifndef _BuiltinFailRelation_H_
#define _BuiltinFailRelation_H_

#include "BuiltinRelation.h"

#include "TupleIterator.h"

/*****************************************************************************/

class corBuiltinFailRelation : public corBuiltinRelation {
public:
    corBuiltinFailRelation(int a, Name n) : corBuiltinRelation(a,n,NULL) {}

    virtual corBindEnv* get_next(corTupleIterator& iterator) {
        iterator.set_no_match();
        return iterator.bindenv;
    }
};

/*****************************************************************************/

#endif _BuiltinFailRelation_H_

