/*****************************************************************************/
//    AggSelInfo.h
/*****************************************************************************/

#ifndef _AggSelInfo_H_
#define _AggSelInfo_H_

#include "Arg.h"
#include "ArgList.h"
#include "BindEnv.h"

/*****************************************************************************/

class corAggSelInfo {
public:
    corArgList* arglist;           //    Arglist that covers literal
    corArgList* groupbylist;       //    Arglist with groupby vars common with
                                //        `arglist', and other vars distinct.
                                //        Used for indexing
    AggregateKind agg_kind;
    corCArg agg_value;             //    Aggregated argument of arglist
    corCArg gb_agg_value;          //    Aggregated argument of groupbylist
    int var_count;
    corBindEnv* bindenv;           //    So it can be reused.
    int indexnum;               //    Used to avoid repeated checks for what
                                //        index to use
    corAggSelInfo *next;
};

/*****************************************************************************/

#endif _AggSelInfo_H_

