/*****************************************************************************/
//    Annotations.h
/*****************************************************************************/

#ifndef _Annotations_H_
#define _Annotations_H_

#include "ArgList.h"
#include "SymbolArg.h"
//#include "PredAnnotations.h"
//#include "ParserStruct.h"
#include "BitVector.h"
#include "CArg.h"

/***************************************************************************/

class corPredAnnotations;
class corParserStruct;

/***************************************************************************/

class corAliasList {
public:
};

/***************************************************************************/

class corRuleAnno {
public:
    corRuleAnno *next;
};

/***************************************************************************/

class corRuleAnnoCase {
public:
    corRuleAnnoCase *next;
};

/***************************************************************************/

class corRuleAnnoCaseDetails{
public:

};

/***************************************************************************/

class corRuleAnnoCaseName{
public:
};

/***************************************************************************/

class corRuleAnnotes {
public:
};

/***************************************************************************/

int corduplicate_index(corPredAnnotations *annos, corSymbol *pred,
    corBitVector *bv,corArgList *al1, int num_vars, corArgList *al2);

void coradd_make_index_annotation(corPredAnnotations *& annos, Name p,
    Name a , corArgList *al1, corArgList *al2);

void coradd_make_index_annotation(corPredAnnotations *& annos, corCArg *cp,
    corCArg *ca ,corArgList *a1, corArgList *a2);

void coradd_make_index_annotation(corPredAnnotations*& annos, Name p,
    corBitVector *bv, corArgList *al1, corArgList *al2);

void coradd_prioritize_annotation(corParserStruct& corparserStruct, corCArg* pred,
    corCArg* adorn_string, corArgList *al1, corCArg *op_arg);

void coradd_agg_sel_annotation(corParserStruct& corparserStruct, corCArg* pred,
    corCArg* adorn_string, corArgList *al1, corArgList *al2, corCArg *op_arg);

void coradd_allowed_adornment(corParserStruct& corparserStruct, corCArg* pred_name,
    corArgList* args);

void coradd_allowed_adornment(corParserStruct& corparserStruct, Name pred_name,
    char* adorn_string, int adorn_length);

void coradd_disallowed_adornment(corParserStruct& corparserStruct, corCArg* pred_name,
    corArgList* args);
void coradd_disallowed_adornment(corParserStruct& corparserStruct, Name pred_name,
    char* adorn_string, int adorn_length);

void coradd_multiset_annotation(corParserStruct& corparserStruct, corCArg* pred,
    corArgList *al1, int check_subsum);

void coradd_diskrel_annotation(corParserStruct& corparserStruct, corCArg* pred,
    corCArg* adorn_string, corArgList *al1);

void corupdate_anno_list(Name name, corBitVector &adorn, corPredAnnotations *anno);
void corupdate_annotations(Name name, corBitVector& adorn);

void corannotation_error(corPredAnnotations *anno, char *msg);

void coradd_index_delta_annotation(corParserStruct&, corCArg*, corArgList*);
void coradd_index_delta_annotation();

corRuleAnnoCaseDetails* cormake_anno_case_details(corCArg* );
corRuleAnnoCaseDetails* cormake_anno_case_details(ArgPtr);
corRuleAnnoCaseDetails* cormake_anno_case_details(corRuleAnnoCase *);

corRuleAnnoCaseName* cormake_anno_case_name(corCArg* );
corRuleAnnoCaseName* cormake_anno_case_name(ArgPtr);

corRuleAnnoCase* corlink_anno_case_list(corRuleAnnoCase*, corRuleAnnoCase*);

corRuleAnno* corlink_rule_anno(corRuleAnno*, corRuleAnno*);

corRuleAnnoCase* cormake_anno_case(corRuleAnnoCaseName*, corRuleAnnoCaseDetails*);

corRuleAnno* cormake_anno(corCArg* , corRuleAnnoCaseDetails*);

/***************************************************************************/

#endif _Annotations_H_

