/*****************************************************************************/
//    DerivedMethod.h
/*****************************************************************************/

#ifndef _DerivedMethod_H_
#define _DerivedMethod_H_

#include "BitVector.h"
#include "StorageRelation.h"

/*****************************************************************************/

class corQFModuleData;

/*****************************************************************************/
// Map adornment to a routine for solving a query with that adornment.

struct corDerivedMethod {
    corDerivedMethod* next;
    corBitVector& adornment;
    InterpDerivedSolver interp_solver;
    corQFModuleData *md;        // Redundant when using the compiled form 
    int valid_method;
    corDerivedMethod(Name, corBitVector&, InterpDerivedSolver, corQFModuleData *);
    ~corDerivedMethod();
};

/*****************************************************************************/

#endif _DerivedMethod_H_

