/*****************************************************************************/
//    ObjectCount.h
/*****************************************************************************/

#ifndef _ObjectCount_H_
#define _ObjectCount_H_

#include <stdio.h>

/*****************************************************************************/

extern int corC_NewFunctorCount;
extern int corC_NewFunctorSize;
extern int corC_DeleteFunctorCount;
extern int corC_DeleteFunctorSize;
extern int corC_NewArgListCount;
extern int corC_NewArgListSize;
extern int corC_NewTupleCount;
extern int corC_NewTupleSize ;
extern int corC_DeleteTupleCount;
extern int corC_DeleteTupleSize ;
extern int corC_ConstructEnvCount;
extern int corC_ConstructEnvSize;
extern int corC_DestructEnvCount;
extern int corC_DestructEnvSize;
extern int corC_NewIntCount, corC_NewDoubleCount;
extern int corC_NewGArraySize;
extern int corC_DeleteGArraySize;
extern int corC_NewHashIndex, corC_NewHashIndexSize;
extern int corC_DeleteHashIndex, corC_DeleteHashIndexSize;
extern int corC_NewHashRelation, corC_DeleteHashRelation;
extern int corC_PipelinedConstructs, corC_PipelinedDestructs;
extern int corC_tupleiterConstructs, corC_tupleiterDestructs;

/*****************************************************************************/

void corDumpCounts(FILE *fd = stdout);
void corResetCounts();

/*****************************************************************************/

#endif _ObjectCount_H_

