#ifndef _RDBINGRESSYSTEM_H_
#define _RDBINGRESSYSTEM_H_

#include "RdbSystem.h"
#include "String.h"


class RdbIngresSystem
: public RdbSystem
{
  public:

    RdbIngresSystem();
    
    virtual String SystemName() const;	// "ingres"

    RdbDatabase* OpenDatabase(const String dbName,
			      const String userid = String(),
			      const String password = String(),
			      const String serverName = String() );
				// open an ingres database

    virtual void const* Implementor() const;

  private:

    RdbIngresSystem(const RdbIngresSystem&); // not allowed

    RdbIngresSystem& operator =(const RdbIngresSystem&); // not allowed

};


#include "RdbIngresSystem.i"

#endif // _RDBINGRESSYSTEM_H_
