/*****************************************************************************/
//    DerivedRelation.h
/*****************************************************************************/

#ifndef _DerivedRelation_H_
#define _DerivedRelation_H_

#include "Relation.h"

#include "DerivedMethod.h"

/*****************************************************************************/

class corDerivedRelation : public corRelation {
public:
    corDerivedRelation(Name name, int arity);
    corDerivedRelation() { }
    virtual ~corDerivedRelation();
    corDerivedMethod *methods;
    virtual corBindEnv *get_next(corTupleIterator&);
    virtual corTuple  *get_next_tuple(corTupleIterator& it);
    virtual void release(corTupleIterator&);
    virtual void print_name(FILE *file);
    virtual void print_facts(FILE *file, corArgList *arglist = NULL) const;
    virtual int insert_new(corArgList& args, corBindEnv* env,
        corBindEnv *dont_rename_env = NULL, corTuple *parent_goal = NULL,
        int dont_rename = 0);
    virtual int insert_tuple(corTuple *tuple){
        return insert_new(tuple->args(), tuple->bindenv);
    }
};

/*****************************************************************************/

int corandOptionToRelation(corRelation *rel, char *adorn_form, RelationOptions coropt);
int cororOptionToRelation(corRelation *rel, char *adorn_form, RelationOptions coropt);

/*****************************************************************************/

#endif _DerivedRelation_H_

