/*****************************************************************************/
//    IndexStruct.h
/*****************************************************************************/

#ifndef _IndexStruct_H_
#define _IndexStruct_H_

#include "BitVector.h"

/*****************************************************************************/

enum PersIndexKind {
    COR_BPLUSTREE,
    COR_HASHTABLE
};

/*****************************************************************************/
// Dummy generic class declaration. In case hash indexes are added later.

class corIndexStruct  {
public:
    // Number of attributes on which the index is created
    int arity;

    //    virtual void operator=(PersistentIndex& index2) = 0 ;

    virtual PersIndexKind kindof() = 0 ;
    virtual int valid() = 0 ;
    virtual void create(corBitVector *, int, int) = 0 ;
    virtual void insert(USERDESC *, corSchema&) = 0;
    virtual int matches(char *, int) = 0;
    virtual void destroy() = 0 ;
    virtual void corprint_adornment(FILE *outf) = 0;
};

/*****************************************************************************/

#endif _IndexStruct_H_

